;  calc2PelsSmall and calc2PelsBig
;  Copyright 2004 by Seva Redkin <redkin@smartchat.net.au>
;  All rights reserved.
; 
;  Redistribution and use in source and binary forms, with or without
;  modification, are permitted provided that the following conditions
;  are met:
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above copyright
;     notice, this list of conditions and the following disclaimer in the
;     documentation and/or other materials provided with the distribution.
; 
;  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
;  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
;  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  SUCH DAMAGE.
; 


; This is nasm (http://nasm.sourceforge.net) source file.
; To make object file out of that use nasm/nasmw
; on the command line like that:
; nasm -f win32 -O2 calcpels.s

SECTION .data

xff00_ffff_ff00_ffff:
	dd	0xff00ffff
	dd	0xff00ffff
xffff_ffff_ffff_ffff:
	dd	0xffffffff
	dd	0xffffffff
x0000_0001_0000_0001:
	dd	0x00000001
	dd	0x00000001
x0000_00ff_ff00_ffff:
	dd	0xff00ffff
	dd	0x000000ff
xff00_ffff_0000_00ff
	dd	0x000000ff
	dd	0xff00ffff
x0000_0000_0000_0000:
	dd	0x00000000
	dd	0x00000000

SECTION .text
	GLOBAL	_calc2PelsSmall

;;	void calc2PelsSmall(
;;	[esp+ 4] unsigned int src,
;;	[esp+ 8] int x,
;;	[esp+12] int diameter,
;;	[esp+16] const unsigned char** line,
;;	[esp+20] unsigned int luma_t,
;;	[esp+24] unsigned int chroma_t);
;;	[esp+28] unsigned int;  dst);

_calc2PelsSmall:

	push	esi
	push	edi
	push	ebx

	pxor	mm6,mm6		; just zero

	movd	mm0,[esp+4+12]	; mm0 is ____VYUY
	pxor	mm1,mm1		; mm1 is sum VVYYUUYY
	punpcklbw	mm0,mm6
	pshufw	mm3,mm0,0xc6
	packuswb	mm0,mm3
	pxor	mm7,mm7		; mm7 is counters
	pand	mm0,[xff00_ffff_ff00_ffff]

	mov	ebx,[esp+24+12]
	mov	eax,[esp+20+12]
	shl	ebx,8
	or	eax,ebx
	movd	mm2,eax
	pshufw	mm2,mm2,0	; mm2 is CLCLCLCL chroma/luma threshhold

	mov	esi,[esp+16+12]
	xor	ecx,ecx

.loop0:
	mov	ebx,[esi+4*ecx]	; ebx is line[h]
	add	ebx,[esp+ 8+12]	; ebx is &(line[h][x])
	mov	edx,[esp+12+12]
	dec	edx
	neg	edx ; edx is w

	mov	edi,edx
	or	edi,3
	
	mov	al,[ebx+edi]	; v
	shl	eax,16
	mov	al,[ebx+edi-2]	; u
	shl	eax,8
	mov	al,[ebx+edx]	; y

	inc	ecx

	align 16
.loop1:
	movd	mm3,eax

	add	edx,2
	mov	edi,edx
	or	edi,3

	mov	al,[ebx+edi]	; v
	shl	eax,16
	mov	al,[ebx+edi-2]	; u
	shl	eax,8
	mov	al,[ebx+edx]	; y
	movd	mm4,eax
	punpckldq	mm3,mm4

	movq	mm4,mm0
	pmaxub	mm4,mm3
	movq	mm5,mm0
	pminub	mm5,mm3
	psubb	mm4,mm5
	pmaxub	mm4,mm2
	pcmpeqb	mm4,mm2
	pcmpeqd	mm4,[xffff_ffff_ffff_ffff]
	movq	mm5,mm4
	pand	mm5,[x0000_0001_0000_0001]
	paddd	mm7,mm5	; increment the counters
	pand	mm3,[x0000_00ff_ff00_ffff]
	pshufw	mm5,mm3,0xfb
	por	mm3,mm5
	punpcklbw	mm3,mm6
	pshufw	mm4,mm4,0x20
	pand	mm3,mm4
	paddw	mm1,mm3	; store sum

	cmp	edx,[esp+12+12]
	jl	.loop1
;; end of loop1

	cmp	ecx,[esp+12+12]
	jl	.loop0

;; ok mm1 is sum should be devided by counters (mm7)
	mov	edi,[esp+28+12]
	pextrw	eax,mm1,2
	pextrw	edx,mm7,2
	mov	ecx,edx
	shr	ecx,1
	add	eax,ecx
	div	dl
	mov	bl,al
	pextrw	eax,mm1,3
	pextrw	edx,mm7,0
	mov	ecx,edx
	shr	ecx,1
	add	eax,ecx
	div	dl
	mov	bh,al
	shl	ebx,16
	pextrw	eax,mm1,0
	add	eax,ecx
	div	dl
	mov	bl,al
	pextrw	eax,mm1,1
	add	eax,ecx
	div	dl
	mov	bh,al
	mov	[edi],ebx

	emms
	pop	ebx
	pop	edi
	pop	esi
	ret

	GLOBAL	_calc2PelsBig

;;	void calc2PelsSmall(
;;	[esp+ 4] unsigned int src,
;;	[esp+ 8] int x,
;;	[esp+12] int diameter,
;;	[esp+16] const unsigned char** line,
;;	[esp+20] unsigned int luma_t,
;;	[esp+24] unsigned int chroma_t);
;;	[esp+28] unsigned int;  dst);

	align 16

_calc2PelsBig:

	push	esi
	push	edi
	push	ebx

	pxor	mm6,mm6		; mm6 is part of the sum VVVVYYYY

	movd	mm3,[esp+4+12]
	pxor	mm1,mm1		; mm1 is part of the sum UUUUYYYY
	punpcklbw	mm3,mm6
	pshufw	mm0,mm3,0xc6
	packuswb	mm0,mm3
	pxor	mm7,mm7		; mm7 is counters
	pand	mm0,[xff00_ffff_ff00_ffff] ; mm0 is V0UYV0UY

	mov	ebx,[esp+24+12]
	mov	eax,[esp+20+12]
	shl	ebx,8
	or	eax,ebx
	movd	mm2,eax
	pshufw	mm2,mm2,0	; mm2 is CLCLCLCL chroma/luma threshhold

	mov	esi,[esp+16+12]
	xor	ecx,ecx

.loop0:
	mov	ebx,[esi+4*ecx]	; ebx is line[h]
	add	ebx,[esp+ 8+12]	; ebx is &(line[h][x])
	mov	edx,[esp+12+12]
	dec	edx
	neg	edx ; edx is w

	mov	edi,edx
	or	edi,3
	
	mov	al,[ebx+edi]	; v
	shl	eax,16
	mov	al,[ebx+edi-2]	; u
	shl	eax,8
	mov	al,[ebx+edx]	; y

	inc	ecx

	align 16
.loop1:
	movd	mm4,eax

	add	edx,2
	mov	edi,edx
	or	edi,3

	mov	al,[ebx+edi]	; v
	shl	eax,16
	mov	al,[ebx+edi-2]	; u
	shl	eax,8
	mov	al,[ebx+edx]	; y
	movd	mm3,eax
	punpckldq	mm3,mm4

	movq	mm4,mm0
	pmaxub	mm4,mm3
	movq	mm5,mm0
	pminub	mm5,mm3
	psubb	mm4,mm5
	pmaxub	mm4,mm2
	pcmpeqb	mm4,mm2
	pcmpeqd	mm4,[xffff_ffff_ffff_ffff]
	movq	mm5,mm4
	pand	mm5,[x0000_0001_0000_0001]
	paddd	mm7,mm5	; increment the counters
	pand	mm3,[xff00_ffff_0000_00ff]
	pshufw	mm5,mm3,0x15
	por	mm3,mm5
	punpckhbw	mm3,[x0000_0000_0000_0000]
	movq	mm5,mm3
	punpckhwd	mm5,[x0000_0000_0000_0000]
	pand	mm5,mm4
	paddd	mm6,mm5 ; store sum
	punpcklwd       mm3,[x0000_0000_0000_0000]
	pshufw	mm4,mm4,0xee
	pand	mm3,mm4
	paddd	mm1,mm3	; store sum

	cmp	edx,[esp+12+12]
	jl	.loop1
;; end of loop1

	cmp	ecx,[esp+12+12]
	jl	.loop0

;; ok mm1 and mm6 is sum should be devided by counters (mm7)
	mov	edi,[esp+28+12]
	movd    eax,mm6
	movd	esi,mm7
        mov     ecx,esi
        shr     ecx,1
        add     eax,ecx
        mov     edx,eax
        shr     edx,16
        div     si
        mov     bl,al
        punpckhdq       mm6,mm6
        movd    eax,mm6
	pextrw  esi,mm7,2
        mov     ecx,esi
        shr     ecx,1
        add     eax,ecx
        mov     edx,eax
        shr     edx,16
        div     si
        mov     bh,al
        shl     ebx,16
        movd    eax,mm1
        add     eax,ecx
        mov     edx,eax
        shr     edx,16
        div     si
        mov     bl,al
        punpckhdq       mm1,mm1
        movd    eax,mm1
        add     eax,ecx
        mov     edx,eax
        shr     edx,16
        div     si
        mov     bh,al
	mov	[edi],ebx

	emms
	pop	ebx
	pop	edi
	pop	esi
	ret
